#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}



int main(int argc, char *argv[]){
	FILE *fi;
	long tbl_size;
	char *tbl;

	if(2 > argc){
		printf("bid_cut.exe [infile]\n");
		exit(0);
	}

	{
		char buf[16];
		fi = fopen(argv[1], "rb");
		if(NULL == fi){
			printf("%s ݂܂\n", argv[1]);
			exit(1);
		}

		fseek(fi, 0x1e, SEEK_SET);
		fread(buf, 1, 4, fi);
		tbl_size = get_dword(buf);
		tbl = malloc(tbl_size);
		if(NULL == tbl){
			fclose(fi);
			printf("sł\n");
			exit(1);
		}
		fseek(fi, 0, SEEK_SET);
		fread(tbl, 1, tbl_size, fi);
	}

	{
		FILE *fo;
		long ofs;
		long t_ofs, t_size;
		char t_name[16];
		char *buf;

		ofs = 16;
		while(ofs < tbl_size){
			memset(t_name, 0, sizeof(t_name));
			memcpy(t_name, (tbl + ofs + 2), 12);
			t_ofs = get_dword(tbl + ofs + 0x0e);
			t_size = get_dword(tbl + ofs + 0x12);
			printf("%-12s  %06x  %d\n", t_name, t_ofs, t_size);

			buf = malloc(t_size);
			if(NULL == buf){
				printf("sł\n");
				free(tbl);
				fclose(fi);
				exit(1);
			}

			fseek(fi, t_ofs, SEEK_SET);
			fread(buf, 1, t_size, fi);

			fo = fopen(t_name, "wb");
			fwrite(buf, 1, t_size, fo);
			fclose(fo);

			free(buf);
			ofs += 0x16;
		}
	}

	free(tbl);
	fclose(fi);
	exit(0);
}
